#ifndef IMAGEVIEW_H
#define IMAGEVIEW_H

#include <QWidget>
#include <QImage>
#include <QLabel>
#include <QSlider>
#include <QAction>

#include "detri2qt.h"

class ImageView : public QWidget
{
    Q_OBJECT
public:
    explicit ImageView(QWidget *parent = nullptr);

    int    num;    // number of images.
    QImage *images;
    QLabel *imageLabel;
    int    img_idx;  // image idx in [0, num-1].

    QTimer *timer;
    QSlider *_slider;

    QLabel *imageMaxCount;   // in Toolbar
    QLabel *imageCountLabel; // in Toolbar

    void loadImages(detri2::arraypool *imgarray);
    void setImage(const QImage *newImage);

private:
    QAction *playAct;
    QAction *pauseAct;
    QAction *stopAct;
    QAction *gotofirstAct;
    QAction *gotolastAct;
    QAction *forwardAct;
    QAction *backwardAct;

signals:

public slots:
    void play_act();
    void setSliderValue(int);
    void update_image();

protected:
   // void mousePressEvent(QMouseEvent *event) override;
};

#endif // IMAGEVIEW_H
