#ifndef MESHOPTIONPANEL_H
#define MESHOPTIONPANEL_H

#include <QObject>
#include <QWidget>

#include <QGridLayout>
//#include <QVBoxLayout>
//#include <QHBoxLayout>
#include <QGroupBox>
#include <QRadioButton>
#include <QCheckBox>
#include <QLabel>
#include <QLineEdit>
#include <QPushButton>
#include <QComboBox>

class meshoptionPanel : public QWidget
{
    Q_OBJECT
public:
    explicit meshoptionPanel(void* scribblearea, QWidget *parent = nullptr);

    void *_scribblearea;

    // Mesh algorithms
    QRadioButton *op_Convexhull;
    QRadioButton *op_Delaunay;
    QRadioButton *op_CDT;
    QRadioButton *op_Quality;
    QRadioButton *op_Flip;
    QRadioButton *op_Smooth;

    // weighted Delaunay options
    QRadioButton *op_DT;
    QRadioButton *op_FDT;
    QCheckBox *op_weighted;
    QCheckBox *op_no_sort;
    QCheckBox *op_no_flip;

    // Mesh quality options
    QLineEdit *line_op_minlen;
    QLineEdit *line_op_maxarea;
    QLineEdit *line_op_minangle;
    QCheckBox *op_metric;

    QComboBox *_cb_smooth_methods;
    QLineEdit *line_smooth_iters;

    QCheckBox *op_dump_to_ucd;
    QCheckBox *op_dump_lift_map;
    QLineEdit *line_dump_file_name;
    QPushButton *btnfilename;

    QPushButton *btnGenerate;
    QPushButton *btnAnimation;
    QPushButton *btnClear;
    QPushButton *btnClose;

signals:

public slots:
    void on_filename();

    void generate();
    void show_animation();
    void clear_mesh();
    void close();
};

#endif // MESHOPTIONPANEL_H
