#include "segmentpanel.h"
#include "scribblearea.h"

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QDebug>

/*
segmentPanel::segmentPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    QVBoxLayout* vLayout = new QVBoxLayout(this);

    _ends = new QLabel;
    _ends->setText("-1, -1");

    vLayout->addWidget(_ends);

    QLabel *tag_lbl = new QLabel(tr("tag"));
    QLabel *maxlen_lbl = new QLabel(tr("max length"));
    _tag = new QLineEdit;
    _maxlen = new QLineEdit;
    _tag->setText(tr("-1"));
    _maxlen->setText(tr("0"));
    QGridLayout* gLayout = new QGridLayout(this);
    gLayout->addWidget(tag_lbl,0,0);
    gLayout->addWidget(_tag,0,1);
    gLayout->addWidget(maxlen_lbl,1,0);
    gLayout->addWidget(_maxlen, 1,1);

    vLayout->addLayout(gLayout);

    _applybtn = new QPushButton(tr("Apply"));
    _closebtn = new QPushButton(tr("Close"));

    vLayout->addWidget(_applybtn); // , 0, Qt::AlignLeft
    vLayout->addWidget(_closebtn); // , 0, Qt::AlignRight

    connect(_applybtn, SIGNAL(clicked()), this, SLOT(on_apply()));
    connect(_closebtn, SIGNAL(clicked()), this, SLOT(on_close()));

    setLayout(vLayout);
    setWindowTitle(tr("Segment"));
}
*/

segmentPanel::segmentPanel(void *scribblearea, QWidget *parent) : QWidget(parent)
{
    _scribblearea = scribblearea;

    _ends = new QLabel;
    _ends->setText("-1, -1");
    QLabel *tag_lbl = new QLabel(tr("tag"));
    QLabel *maxlen_lbl = new QLabel(tr("max length"));
    _tag = new QLineEdit;
    _maxlen = new QLineEdit;
    _tag->setText(tr("-1"));
    _maxlen->setText(tr("0"));

    _applybtn = new QPushButton(tr("Apply"));
    _closebtn = new QPushButton(tr("Close"));

    connect(_applybtn, SIGNAL(clicked()), this, SLOT(on_apply()));
    connect(_closebtn, SIGNAL(clicked()), this, SLOT(on_close()));

    QGridLayout* gLayout = new QGridLayout(this);
    gLayout->addWidget(_ends,0,0);
    gLayout->addWidget(tag_lbl,1,0);
    gLayout->addWidget(_tag,1,1);
    gLayout->addWidget(maxlen_lbl,2,0);
    gLayout->addWidget(_maxlen, 2,1);
    gLayout->addWidget(_applybtn,3,0);
    gLayout->addWidget(_closebtn, 3,1);

    setLayout(gLayout);
    setWindowTitle(tr("Segment"));
}

void segmentPanel::on_apply()
{
    //qDebug()<<"apply!";
    if (_scribblearea) {
      ScribbleArea *sa = (ScribbleArea *) _scribblearea;
      if (sa->_active_segment != NULL) {
        detri2::Triang *seg = sa->_active_segment;
        while (seg != NULL) {
          seg->tag = _tag->text().toInt();
          seg->val = _maxlen->text().toDouble();
          seg = seg->Next;
        }
      }
    }
    hide();
}

void segmentPanel::on_close()
{
    hide();
}
